#-------------------------------------------------------------------------------
# Name:        XCSMainApp.py
# Purpose:     Translation of the XCS system to Python
#
# Author:      Jose Antonio Martin H. <jamartin@dia.fi.upm.es>
#
# Created:     16/01/2007
# Copyright:   (c) Jose Antonio Martin H. 2007
# Licence:     <GPL>
#-------------------------------------------------------------------------------
#!/usr/bin/env python
from XCS import *
import time
from MPEnvironment import *
from MazeEnvironment import *
import sys
argv = sys.argv

envFileString=""
e = Environment()

XCSConstants.setSeed(1 + time.clock() % 10000)


helpstr = """
Parameter Usage:
    1: mp                   or maze
    2: problemLength(1-)    or mazeEnvironment
    3: payoffLandscape(0,1) or codingLength(2,3)}
    4: OutputFileName
    5: Optional NumberOfTrials
    6: Optional NumberOfExperiments
    
Thus:
Usage:
python XCSTest.py {mp|maze} {problemLength(1-)|mazeEnvironment} {payoffLandscape(0,1)|codingLength(2,3)} {OutputFileName} ; optionals: {MaxNumberOfTrials} {NumberOfExperiments}"
example: python XCSTest.py maze Maze1.txt 2 OutResults.txt 200 1
"""

if len(argv) >= 4 and argv[1]=="maze" or argv[1]=="mp":

    if argv[1]=="maze":
        print "Construct maze environment with maze coded in "+argv[2]+" coding each feature with "+argv[3]+" bits"
        e = MazeEnvironment(argv[2],int(argv[3]))

    else:
        print "Construct Multiplexer problem of length "+argv[2]+" and payoff type "+argv[3]
        e = MPEnvironment(int(argv[2]), int(argv[3]))


else:
    # In case of a wrong number of arguments print out the usage.
    print helpstr
    #print "Usage: python XCSTest.py {mp|maze} {problemLength(1-)|mazeEnvironment} {payoffLandscape(0,1)|codingLength(2,3)} {OutputFileName}  optionals:{MaxNumberOfTrials} {NumberOfExperiments}"
    sys.exit()





xcs = XCS(e, argv[4])

if len(argv) > 4:
    xcs.setNumberOfTrials(int(args[4]))

if len(argv) > 5:
    xcs.setNumberOfExperiments(int(args[5]))

xcs.runXCS()

